#ifndef HASHPROBE_H_INCLUDED
#define HASHPROBE_H_INCLUDED

#include "types.h"

#include <deque>
#include <string>

#include <grpc/grpc.h>
#include <grpc++/server.h>
#include <grpc++/server_builder.h>
#include "hashprobe.grpc.pb.h"

class HashProbeImpl final : public hashprobe::HashProbe::Service {
public:
	grpc::Status Probe(grpc::ServerContext* context,
	                   const hashprobe::HashProbeRequest* request,
			   hashprobe::HashProbeResponse *response);

private:
	void FillMove(Position* pos, Move move, hashprobe::HashProbeMove* decoded);
	void ProbeMove(Position* pos, std::deque<StateInfo>* setup_states, bool invert, hashprobe::HashProbeLine* response);
	void FillValue(Value value, hashprobe::HashProbeScore* score);
};

class HashProbeThread {
public:
	HashProbeThread(const std::string &server_address);
	void Shutdown();

private:
	HashProbeImpl service;
	grpc::ServerBuilder builder;
	std::unique_ptr<grpc::Server> server;
};

#endif 
